//+------------------------------------------------------------------+
//|                                                 strategy_cci.mqh |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2010
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import
//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex5"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+
class C_cci
  {
private:
   double            m_Risk;
   double            m_Ksl;
   double            m_Ktp;
   int               m_Period_CCI_S;
   int               m_Period_CCI_F;
   int               m_Period_ATR;
   ENUM_TIMEFRAMES   m_TF_ATR;
   string            m_CommentOrder;

   int               m_cci_s;
   int               m_cci_f;
   //double            CCI_S1;
   //double            CCI_S2;
   //double            CCI_F1;
   //double            CCI_F2;
   double            m_SL;
   double            m_TP;
   int               m_atr;

   MqlTradeRequest   m_request;         // request data
   MqlTradeResult    m_result;          // result data
   MqlTradeCheckResult m_check_result;  // result check data


public:
   ENUM_ORDER_TYPE   trend;
   ENUM_ORDER_TYPE   signal;
                     C_cci(double risk,double ksl,double ktp,int period_CCI_S,int period_CCI_F,int period_ATR,ENUM_TIMEFRAMES tf_ATR,string commentOrder);
                    ~C_cci();
   ENUM_ORDER_TYPE   GetSignal_mt5(string symbol);
   ENUM_ORDER_TYPE   GetSignal_mt4(string symbol);
   int               arrow(ENUM_ORDER_TYPE sig);
   color             colorarrow(ENUM_ORDER_TYPE sig);
   void              strategy_cci_mt5(string symbol);
   void              OrderOpen(string symbol,ENUM_ORDER_TYPE type);
   int               DigitsVolume(string symbol);
   void              ModifyTP(string symbol);
   void              ModifySL(string symbol);
   double            DynamicStop(string symbol);
   void              OrderClose(string symbol,ENUM_ORDER_TYPE type);
  };
//+------------------------------------------------------------------+
void C_cci::C_cci(double risk,double ksl,double ktp,int period_CCI_S,int period_CCI_F,int period_ATR,ENUM_TIMEFRAMES tf_ATR,string commentOrder)
  {
   m_Risk=risk;
   m_Ksl=ksl;
   m_Ktp=ktp;
   m_Period_CCI_S=period_CCI_S;
   m_Period_CCI_F=period_CCI_F;
   m_Period_ATR=period_ATR;
   m_TF_ATR=tf_ATR;
   m_CommentOrder=commentOrder;
   trend=WRONG_VALUE;
  }
//+------------------------------------------------------------------+
void C_cci::~C_cci(void)
  {
  }
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE C_cci::GetSignal_mt5(string symbol)
  {
   double cci_s[3];
   double cci_f[3];

   if(Bars(symbol,PERIOD_CURRENT)<m_Period_CCI_S+1)return(WRONG_VALUE);
   if(Bars(symbol,m_TF_ATR)<m_Period_ATR+1)return(WRONG_VALUE);

   if(m_cci_s==INVALID_HANDLE ||  m_cci_s==0){m_cci_s=iCCI(symbol,PERIOD_CURRENT,m_Period_CCI_S,PRICE_CLOSE);return(WRONG_VALUE);}
   if(m_cci_f==INVALID_HANDLE ||  m_cci_f==0){m_cci_f=iCCI(symbol,PERIOD_CURRENT,m_Period_CCI_F,PRICE_CLOSE);return(WRONG_VALUE);}

   if(CopyBuffer(m_cci_s,0,0,3,cci_s)<3) return(WRONG_VALUE);
   if(CopyBuffer(m_cci_f,0,0,3,cci_f)<3) return(WRONG_VALUE);

//trend=cci_s[0];
   if(cci_s[1]>100.0)trend=ORDER_TYPE_BUY;
   if(cci_s[1]<-100.0)trend=ORDER_TYPE_SELL;
   if(cci_s[1]>100.0  &&  cci_s[0]<100.0)trend=ORDER_TYPE_BUY;
   if(cci_s[1]<-100.0 && cci_s[0]>-100.0)trend=ORDER_TYPE_SELL;

   if(trend==ORDER_TYPE_BUY)
     {
      if(cci_f[1]<-100.0)return(ORDER_TYPE_BUY);
      if(cci_f[1]<-100.0 && cci_f[0]>-100.0)return(ORDER_TYPE_BUY);
      if(cci_f[1]>-100.0 && cci_f[0]<-100.0)return(ORDER_TYPE_BUY);
      if(cci_f[1]>100.0 && cci_f[0]<100.0)return(ORDER_TYPE_BUY);
      if(cci_f[1]>100.0)return(ORDER_TYPE_BUY);
     }
   if(trend==ORDER_TYPE_SELL)
     {
      if(cci_f[1]>100)return(ORDER_TYPE_SELL);
      if(cci_f[1]>100 && cci_f[0]<100)return(ORDER_TYPE_SELL);
      if(cci_f[1]<100 && cci_f[0]>100)return(ORDER_TYPE_SELL);
      if(cci_f[1]<-100 && cci_f[0]>-100)return(ORDER_TYPE_SELL);
      if(cci_f[1]<-100)return(ORDER_TYPE_SELL);
     }

   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE C_cci::GetSignal_mt4(string symbol)
  {
//   if(iBars(symbol,PERIOD_CURRENT)<period_CCI_S+1)return(WRONG_VALUE);
//
//   CCI_S1=iCCI(symbol,PERIOD_CURRENT,m_Period_CCI_S,PRICE_CLOSE,1);
//   CCI_S2=iCCI(symbol,PERIOD_CURRENT,m_Period_CCI_S,PRICE_CLOSE,2);
//
//   CCI_F1=iCCI(symbol,PERIOD_CURRENT,m_Period_CCI_F,PRICE_CLOSE,1);
//   CCI_F2=iCCI(symbol,PERIOD_CURRENT,m_Period_CCI_F,PRICE_CLOSE,2);
//
//   if(CCI_S1>100.0)trend=OP_BUY;
//   if(CCI_S2<-100.0)trend=OP_SELL;
//
//   if(CCI_S1>100.0  && CCI_S2<100.0)trend=OP_BUY;
//   if(CCI_S2<-100.0 &&CCI_S2>-100.0)trend=OP_SELL;
//
//   if(trend==OP_BUY || CCI_S1>100.0)
//     {
//      if(CCI_F1<-100.0)return(OP_BUY);
//      if(CCI_F1<-100.0 && CCI_F2>-100.0)return(OP_BUY);
//      if(CCI_F1>-100.0 && CCI_F2<-100.0)return(OP_BUY);
//      if(CCI_F1>100.0 && CCI_F2<100.0)return(OP_BUY);
//      if(CCI_F1>100.0)return(OP_BUY);
//     }
//   if(trend==OP_SELL || CCI_S1<-100.0)
//     {
//      if(CCI_F1>100)return(OP_SELL);
//      if(CCI_F1>100 && CCI_F2<100)return(OP_SELL);
//      if(CCI_F1<100 && CCI_F2>100)return(OP_SELL);
//      if(CCI_F1<-100 && CCI_F2>-100)return(OP_SELL);
//      if(CCI_F1<-100)return(OP_SELL);
//
//     }
//
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
int C_cci::arrow(ENUM_ORDER_TYPE sig)
  {
   if(sig==WRONG_VALUE)return(251);
   if(sig==ORDER_TYPE_BUY)return(233);
   if(sig==ORDER_TYPE_SELL)return(234);
   return(0);
  }
//+------------------------------------------------------------------+
color C_cci::colorarrow(ENUM_ORDER_TYPE sig)
  {
   if(sig==WRONG_VALUE)return(clrMediumAquamarine);
   if(sig==ORDER_TYPE_BUY)return(clrBlue);
   if(sig==ORDER_TYPE_SELL)return(clrRed);
   return(0);
  }
//+------------------------------------------------------------------+
void C_cci::strategy_cci_mt5(string symbol)
  {
   signal=GetSignal_mt5(symbol);
   m_TP=DynamicStop(symbol)*m_Ktp;
   m_SL=DynamicStop(symbol)*m_Ksl;
   if(signal==ORDER_TYPE_BUY)
     {
      OrderClose(symbol,ORDER_TYPE_SELL);
      OrderOpen(symbol,ORDER_TYPE_BUY);
     }
   if(signal==ORDER_TYPE_SELL)
     {
      OrderClose(symbol,ORDER_TYPE_BUY);
      OrderOpen(symbol,ORDER_TYPE_SELL);
     }

   ModifySL(symbol);
   ModifyTP(symbol);
  }
//+------------------------------------------------------------------+
void C_cci::OrderOpen(string symbol,ENUM_ORDER_TYPE type)
  {
   if(type==WRONG_VALUE)return;
   if(PositionSelect(symbol)) return;

   double margin=0.0;
   double tv=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE_PROFIT);
   double MinLot= SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
   double MaxLot= SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);

   double Bid=SymbolInfoDouble(symbol,SYMBOL_BID);
   double Ask=SymbolInfoDouble(symbol,SYMBOL_ASK);
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
   int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);

   if(type==ORDER_TYPE_BUY)
     {
      m_request.price=NormalizeDouble(Ask,digits);
      //OrderCalcMargin(type,symbol,1.0,Ask,margin);
     }
   if(type==ORDER_TYPE_SELL)
     {
      m_request.price=NormalizeDouble(Bid,digits);
      //OrderCalcMargin(type,symbol,1.0,Bid,margin);
     }
   //m_request.volume=(AccountInfoDouble(ACCOUNT_MARGIN_FREE)*m_Risk)/(margin*100.0);
   if(m_SL!=0 && tv!=0) m_request.volume=(AccountInfoDouble(ACCOUNT_MARGIN_FREE)*m_Risk)/(m_SL*tv*100.0);
   if(m_request.volume<MinLot)m_request.volume=MinLot;
   if(m_request.volume>MaxLot)m_request.volume=MaxLot;
   m_request.volume=NormalizeDouble(m_request.volume,DigitsVolume(symbol));

   m_request.comment=m_CommentOrder;

   if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_REQUEST)
     {
      m_request.action=TRADE_ACTION_DEAL;
      m_request.symbol= symbol;
      m_request.sl=0.0;
      m_request.tp=0.0;
      m_request.deviation=10000;
      m_request.type=type;
      m_request.type_filling=ORDER_FILLING_FOK;
     }
   if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_INSTANT)
     {
      m_request.action=TRADE_ACTION_DEAL;
      m_request.symbol= symbol;
      m_request.deviation=10000;
      m_request.sl=0.0;
      m_request.tp=0.0;
      m_request.type=type;
      m_request.type_filling=ORDER_FILLING_FOK;
     }
   if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_MARKET)
     {
      m_request.action=TRADE_ACTION_DEAL;
      m_request.symbol= symbol;
      m_request.type=type;
      m_request.type_filling=ORDER_FILLING_FOK;

     }
   if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_EXCHANGE)
     {
      m_request.action=TRADE_ACTION_DEAL;
      m_request.symbol= symbol;
      m_request.type=type;
      m_request.type_filling=ORDER_FILLING_FOK;

     }

   if(OrderCheck(m_request,m_check_result))
     {
      if(OrderSend(m_request,m_result))
        {
         //if(m_result.retcode==10009)
         //  {
         //   m_FS=false;
         //   PositionSelect(symbol);
         //   m_ID=(int)PositionGetInteger(POSITION_IDENTIFIER);
         //  }
        }
      else Print("OrderSend   - ",m_result.retcode);
     }
   else Print("OrderCheck   - ",m_check_result.retcode);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void C_cci::OrderClose(string symbol,ENUM_ORDER_TYPE type)
  {
   if(type==WRONG_VALUE)return;
   if(PositionSelect(symbol))
     {
      if(PositionGetInteger(POSITION_TYPE)!=type)return;

      double Bid=SymbolInfoDouble(symbol,SYMBOL_BID);
      double Ask=SymbolInfoDouble(symbol,SYMBOL_ASK);
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
      m_request.volume=PositionGetDouble(POSITION_VOLUME);
      m_request.comment=m_CommentOrder;

      if(type==ORDER_TYPE_BUY)
        {
         m_request.price=NormalizeDouble(Ask,digits);
        }
      if(type==ORDER_TYPE_SELL)
        {
         m_request.price=NormalizeDouble(Bid,digits);
        }

      if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_REQUEST)
        {
         m_request.action=TRADE_ACTION_DEAL;
         m_request.symbol= symbol;
         m_request.sl=0.0;
         m_request.tp=0.0;
         m_request.deviation=10000;
         m_request.type=type;
         m_request.type_filling=ORDER_FILLING_FOK;
        }
      if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_INSTANT)
        {
         m_request.action=TRADE_ACTION_DEAL;
         m_request.symbol= symbol;
         m_request.deviation=10000;
         m_request.sl=0.0;
         m_request.tp=0.0;
         m_request.type=type;
         m_request.type_filling=ORDER_FILLING_FOK;
        }
      if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_MARKET)
        {
         m_request.action=TRADE_ACTION_DEAL;
         m_request.symbol= symbol;
         m_request.type=type;
         m_request.type_filling=ORDER_FILLING_FOK;

        }
      if(SymbolInfoInteger(symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_EXCHANGE)
        {
         m_request.action=TRADE_ACTION_DEAL;
         m_request.symbol= symbol;
         m_request.type=type;
         m_request.type_filling=ORDER_FILLING_FOK;

        }

      if(OrderCheck(m_request,m_check_result))
        {
         if(OrderSend(m_request,m_result))
           {
            //if(m_result.retcode==10009)
            //  {
            //   m_FS=false;
            //   PositionSelect(symbol);
            //   m_ID=(int)PositionGetInteger(POSITION_IDENTIFIER);
            //  }
           }
         else Print("OrderSend   - ",m_result.retcode);
        }
      else Print("OrderCheck   - ",m_check_result.retcode);
     }
  }
//+------------------------------------------------------------------+
int C_cci::DigitsVolume(string symbol)
  {
   double LotsStep=SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
   if(LotsStep==0.01)return(2);
   if(LotsStep==0.1)return(1);
   return(0);
  }
//+------------------------------------------------------------------+
void C_cci::ModifyTP(string symbol)
  {
   if(m_TP<=0)return;
   if(PositionSelect(symbol))
     {
      if(PositionGetDouble(POSITION_TP)==0)
        {
         double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
         m_request.action=TRADE_ACTION_SLTP;
         m_request.symbol= symbol;
         int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            m_request.tp=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)+m_TP,digits);
            m_request.sl=PositionGetDouble(POSITION_SL);
           }
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            m_request.tp=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)-m_TP,digits);
            m_request.sl=PositionGetDouble(POSITION_SL);
           }
         if(OrderCheck(m_request,m_check_result))
           {
            if(OrderSend(m_request,m_result)){}
            else Print("  - ",m_result.retcode);
           }
        }
     }
  }
//+------------------------------------------------------------------+
void C_cci::ModifySL(string symbol)
  {
   if(m_SL<=0)return;
   if(PositionSelect(symbol))
     {
      if(PositionGetDouble(POSITION_SL)==0)
        {
         double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
         m_request.action=TRADE_ACTION_SLTP;
         m_request.symbol= symbol;
         int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            m_request.tp=PositionGetDouble(POSITION_TP);
            m_request.sl=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)-m_SL,digits);
           }
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            m_request.tp=PositionGetDouble(POSITION_TP);
            m_request.sl=NormalizeDouble(PositionGetDouble(POSITION_PRICE_OPEN)+m_SL,digits);
           }
         if(OrderCheck(m_request,m_check_result))
           {
            if(OrderSend(m_request,m_result)){}
            else Print("  - ",m_result.retcode);
           }
        }
     }
  }
//+------------------------------------------------------------------+
double C_cci::DynamicStop(string symbol)
  {
   double atr[1];
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
   double Bid=SymbolInfoDouble(symbol,SYMBOL_BID);
   double Ask=SymbolInfoDouble(symbol,SYMBOL_ASK);
   double spred=Ask-Bid;
   if(m_atr==INVALID_HANDLE || m_atr==0){m_atr=iATR(symbol,m_TF_ATR,m_Period_ATR);return(WRONG_VALUE);}
   if(CopyBuffer(m_atr,0,1,1,atr)<1)return(WRONG_VALUE);
   return(atr[0]+spred);
  }
//+------------------------------------------------------------------+
